题目内容
给定一个n个点m条边的有向图,图中可能存在重边和自环,所有边权均为非负值。
请你求出1号点到n号点的最短距离,如果无法从1号点走到n号点,则输出-1。
输入格式
第一行包含整数n和m。
接下来m行每行包含三个整数x,y,z,表示存在一条从点x到点y的有向边,边长为z。
输出格式
输出一个整数,表示1号点到n号点的最短距离。
如果路径不存在,则输出-1。
数据范围
1≤n,m≤1.5×10^5 ,
图中涉及边长均不小于0,且不超过10000。
输入样例
3 3
1 2 2
2 3 1
1 3 4
输出样例
3
题解
采用堆的数据结构来辅助dijkstra算法,这样在求不在s数组中的点t离起点的距离最近的点的时间复杂度可从O(n)变为O(1)。同时,由于采用堆的数据结构,因此每次修改一个点的时间复杂度为mlog(n)。
代码
#include <cstring> #include <iostream> #include <algorithm> #include <queue>
using namespace std;
typedef pair<int, int> PII;
const int N = 1e6 + 10;
int n, m; int h[N], w[N], e[N], ne[N], idx; int dist[N]; bool st[N];
void add(int a, int b, int c) { e[idx] = b, w[idx] = c, ne[idx] = h[a], h[a] = idx ++ ; }
int dijkstra() { memset(dist, 0x3f, sizeof dist); dist[1] = 0; priority_queue<PII, vector<PII>, greater<PII>> heap; heap.push({0, 1});
while (heap.size()) { auto t = heap.top(); heap.pop();
int ver = t.second, distance = t.first;
if (st[ver]) continue; st[ver] = true;
for (int i = h[ver]; i != -1; i = ne[i]) { int j = e[i]; if (dist[j] > distance + w[i]) { dist[j] = distance + w[i]; heap.push({dist[j], j}); } } }
if (dist[n] == 0x3f3f3f3f) return -1; return dist[n]; }
int main() { scanf("%d%d", &n, &m);
memset(h, -1, sizeof h); while (m -- ) { int a, b, c; scanf("%d%d%d", &a, &b, &c); add(a, b, c); }
cout << dijkstra() << endl;
return 0; }
|